//+------------------------------------------------------------------+
//|                                                !OnChartEvent.mqh |
//+------------------------------------------------------------------+
//     
//    
string currVal="";
bool flgDialogWin=false; //   
int
szArrList=0,//    
number=-1; //      
string
nmMsgBx="",  //   
nmValObj=""; //   
//---
//      
string lenum[],lenmObj[];
//---
//    
color
clrBrdBtn=clrWhite,
clrBrdFonMsg=clrDimGray,clrFonMsg=C'15,15,15',
clrChoice=clrWhiteSmoke,clrHdrBtn=clrBlack,
clrFonHdrBtn=clrGainsboro,clrFonStr=C'22,39,38';
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void OnChartEvent(const int     id,
                  const long   &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//  -     " "
   if(NotTest() && SettingOnTheFly)
     {
      //+------------------------------------------------------------------+
      //|  CHARTEVENT_OBJECT_CLICK                                  |
      //+------------------------------------------------------------------+
      if(ChartEvent_ObjectClick(id,lparam,dparam,sparam)) { return; }
      //---
      //+------------------------------------------------------------------+
      //|  CHARTEVENT_OBJECT_ENDEDIT                                |
      //+------------------------------------------------------------------+
      if(ChartEvent_ObjectEndEdit(id,lparam,dparam,sparam)) { return; }
     }
//---
   return;
  }
//+------------------------------------------------------------------+
//|  CHARTEVENT_OBJECT_CLICK                                  |
//+------------------------------------------------------------------+
bool ChartEvent_ObjectClick(int id,long lparam,double dparam,string sparam)
  {
   //       
   if(id==CHARTEVENT_OBJECT_CLICK) // id==1
     {
      Get_STV(); //     
      //---
      string clickedChartObject=sparam; //   
      //---
      //   
      width_chart=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0);
      height_chart=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0);
      //---
      DialogWindowInfoPanel(clickedChartObject);
     }
//---
   return(false);
  }
//+------------------------------------------------------------------+
//| CHARTEVENT_OBJECTS_ENDEDIT                                       |
//+------------------------------------------------------------------+
bool ChartEvent_ObjectEndEdit(int id,long lparam,double dparam,string sparam)
  {
   if(id==CHARTEVENT_OBJECT_ENDEDIT) // id==3
     {
      string editObject=sparam; //   
      //---
      //          
      if(editObject=="editValIP")
        {
         //   
         currVal=ObjectGetString(0,"editValIP",OBJPROP_TEXT);
         //---
         // (0) Period Indicator
         if(number==0)
           {
            //     
            if(currVal=="0" || currVal=="" || SD(currVal)<=0) { currVal="1"; }
            //---
            //   
            ObjectSetString(0,"enumMB0",OBJPROP_TEXT,currVal);
           }
         //---
         // (4) Lot
         if(number==4)
           {
            //     
            if(currVal=="0" || currVal=="" || SD(currVal)<=0) { currVal=DS(SS.vol_min,2); }
            //---
            //   
            ObjectSetString(0,"enumMB0",OBJPROP_TEXT,DS2(SD(currVal)));
           }
         //---
         // (1) Take Profit (p)
         // (2) Stop Loss (p)
         if(number==1 || number==2)
           {
            //     
            if(currVal=="0" || currVal=="" || SD(currVal)<=0) { currVal="1"; }
            //---
            //   
            ObjectSetString(0,"enumMB1",OBJPROP_TEXT,currVal);
           }
         //---         
         DelObjbyName("editValIP"); ChartRedraw();
        }
     }
//---
   return(false);
  }
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
void DialogWindowInfoPanel(string clickObj)
  {
//       
   if(!flgDialogWin)
     {
      //     
      // ,        
      if((number=GetNumberClickedObjIP(clickObj))==-1) { return; }
      //---
      //    
      //     
      if(!InitArraysAndDefault()) { return; }
      //---
      //   
      SetDialogWindow();
      //---
      flgDialogWin=true; // ,    
      ChartRedraw();
     }
   else //    
     {
      //      
      SetEditObjInDialogWindow(clickObj);
      //---
      //       
      if(clickObj=="btnApply" || clickObj=="btnCancel")
        {
         //    Apply ()
         if(clickObj=="btnApply")
           {
            //       
            //       ,     (    ),
            // ...       
            if(currVal!=ObjectGetString(0,nmValObj,OBJPROP_TEXT))
              {
               //    
               ObjectSetString(0,nmValObj,OBJPROP_TEXT,currVal); ChartRedraw();
               //---
               //          
               WriteNewData();
              }
           }
         //---
         DelDialogWindow(lenmObj); //   
         iZeroMemory(); //  
         //---
         //  
         SetParameters();
         GetHandlesIndicators();
         SetInfoPanel();
         //---
         ChartRedraw();
        }
      else //    Apply  Cancel
        {
         //      
         SelectionOptionInDialogWindow(clickObj);
         //---
         ChartRedraw();
        }
     }
  }
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
int GetNumberClickedObjIP(string clckObj)
  {
   int n=-1;
//---
   for(int i=0; i<szArrIP; i++)
     {
      if(clckObj==arr_objip[i][1] || clckObj==arr_objip[i][2]) { n=i; break; }
     }
//---
   return(n);
  }  
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
bool InitArraysAndDefault()
  {
// (0) Period Indicator
// (4) Lot
   if(number==0 || number==4)
     {
      ArrayResize(lenum,1);
      ArrayResize(lenmObj,1);
      lenum[0]="";
      //---
      nmMsgBx=arr_objip[number][0]; //   
      nmValObj=arr_objip[number][2]; //   
      currVal=ObjectGetString(0,nmValObj,OBJPROP_TEXT); //    
      //---
      if(currVal=="0" || currVal=="")
        {
         //     (default)
         switch(number)
           {
            case 0 : lenum[0]="10";  break; // Period Indicator
            case 4 : lenum[0]="0.1"; break; // Lot
           }
        }
      else { lenum[0]=currVal; }
      return(true);
     }
//---
// (1) Take Profit (p)
// (2) Stop Loss (p)
   if(number==1 || number==2)
     {
      ArrayResize(lenum,2);
      ArrayResize(lenmObj,2);
      lenum[0]="FALSE";
      lenum[1]="";
      //---
      nmMsgBx=arr_objip[number][0]; //   
      nmValObj=arr_objip[number][2]; //   
      currVal=ObjectGetString(0,nmValObj,OBJPROP_TEXT); //    
      //---
      if(currVal=="" || currVal=="FALSE")
        {
         //     (default)
         switch(number)
           {
            case 1 : lenum[1]="50"; break; // Take Profit (p)
            case 2 : lenum[1]="10"; break; // Stop Loss (p)
           }
        }
      else { lenum[1]=currVal; }
      return(true);
     }
//---
// (3) Reverse
   if(number==3)
     {
      ArrayResize(lenum,2);
      ArrayResize(lenmObj,2);
      lenum[0]="FALSE";
      lenum[1]="TRUE";
      //---
      nmMsgBx=arr_objip[number][0]; //   
      nmValObj=arr_objip[number][2]; //   
      currVal=ObjectGetString(0,nmValObj,OBJPROP_TEXT); //    
      return(true);
     }
//---
   return(false);
  }
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
void SetDialogWindow()
  {
   int
   fln=16, //  
   hln=12; //  
   int
   corner=CORNER_LEFT_UPPER,
   anchor=ANCHOR_RIGHT_UPPER;
//---
   int
   fonW=200,fonH=100;
//---
   int
   FnHdrX=(width_chart/2)-(fonW/2),
   FnHdrY=(height_chart/2)-(fonH/2),
   applX=(width_chart/2)-(fonW/2)+85,
   cnclX=(width_chart/2)-(fonW/2)+140,
   chcX=width_chart/2+90,
   btnsY=FnHdrY+fonH-25;
//---
   CreateEdit(0,0,"FonMsgBox","",corner,"Arial",8,clrBrdFonMsg,fonW,fonH,FnHdrX,FnHdrY,2,clrFonMsg,1);
   CreateEdit(0,0,"HeaderMsgBox",nmMsgBx,corner,bsc_fnt,8,clrHdrBtn,fonW,16,FnHdrX,FnHdrY,3,clrFonHdrBtn,1);
//---
   CreateButton(0,0,"btnApply","Apply",anchor,corner,bsc_fnt,font_sz,clrHdrBtn,clrFonHdrBtn,clrBrdBtn,50,16,applX,btnsY,3);
   CreateButton(0,0,"btnCancel","Cancel",anchor,corner,bsc_fnt,font_sz,clrHdrBtn,clrFonHdrBtn,clrBrdBtn,50,16,cnclX,btnsY,3);
//---
   szArrList=ArraySize(lenum); //    ( )
//---
   int Y=0;
//    
   for(int i=0; i<szArrList; i++)
     {
      if(i==0) { Y=FnHdrY+fln; } else { Y=FnHdrY+fln+hln*i; }
      //---
      if(currVal==lenum[i])
        { CreateEdit(0,0,"fonStrings","",corner,bsc_fnt,8,clrFonStr,fonW-2,13,FnHdrX+1,Y,3,clrFonStr,1); }
     }
//---
//    
   for(int i=0; i<szArrList; i++)
     {
      lenmObj[i]="enumMB"+IS(i);
      //---
      if(i==0) { Y=FnHdrY+fln; } else { Y=FnHdrY+fln+hln*i; }
      //---
      CreateLabel(0,0,lenmObj[i],lenum[i],anchor,corner,bsc_fnt,font_sz,clrChoice,chcX,Y,4);
     }
  }
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
void SelectionOptionInDialogWindow(string clickObj)
  {
   int corner=CORNER_LEFT_UPPER;
//---
   int
   fln=16, //  
   hln=12, //  
   fonW=200,fonH=100,
   FnHdrX=(width_chart/2)-(fonW/2),
   FnHdrY=(height_chart/2)-(fonH/2);
//---
   string mbname=ObjectGetString(0,clickObj,OBJPROP_NAME); //   -
   string mbcurrVal=ObjectGetString(0,clickObj,OBJPROP_TEXT); //   -
//---
//       ,
//     
   if(mbcurrVal!=currVal && 
      StringFind(mbname,"enumMB",0)>=0)
     {
      DelObjbyName("editValIP"); //   ,   
      //---
      currVal=mbcurrVal; //    
      //---
      //      
      int Y=0;
      for(int i=0; i<szArrList; i++)
        {
         if(i==0) { Y=FnHdrY+fln; } else { Y=FnHdrY+fln+hln*i; }
         //---
         if(currVal==lenum[i])
           { CreateEdit(0,0,"fonStrings","",corner,bsc_fnt,8,clrFonStr,fonW-2,13,FnHdrX+1,Y,3,clrFonStr,1); return; }
        }
     }
  }
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void SetEditObjInDialogWindow(string clickObj)
  {
   int corner=CORNER_RIGHT_UPPER;
//---
   int
   fln=16, //  
   hln=12, //     
   fonH=100, //   
   FnHdrY=(height_chart/2)-(fonH/2);
//---
//    - 1
   if(clickObj=="enumMB0")
     {
      // (0) Period Indicator
      // (4) Lot
      if(number==0 || number==4)
        {
         string nmClkObj=ObjectGetString(0,"enumMB0",OBJPROP_TEXT);
         CreateEdit(0,0,"editValIP",nmClkObj,corner,bsc_fnt,8,clrWhiteSmoke,50,13,width_chart/2-41,FnHdrY+fln,5,clrBlack,0);
         return;
        }
     }
//---
//    - 2
   if(clickObj=="enumMB1")
     {
      // (1) Take Profit (p)
      // (2) Stop Loss (p)
      if(number==1 || number==2)
        {
         string nmClkObj=ObjectGetString(0,"enumMB1",OBJPROP_TEXT);
         CreateEdit(0,0,"editValIP",nmClkObj,corner,bsc_fnt,8,clrWhiteSmoke,50,13,width_chart/2-41,FnHdrY+fln+hln,5,clrBlack,0);
         return;
        }
     }
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
void DelDialogWindow(string &arrObj[])
  {
   Sleep(100);
   DelObjbyName("FonMsgBox");
   DelObjbyName("HeaderMsgBox");
//---
   int szArr=ArraySize(arrObj);
   for(int i=0; i<szArr; i++)
     { DelObjbyName(arrObj[i]); }
//---
   DelObjbyName("btnApply");
   DelObjbyName("btnCancel");
   DelObjbyName("fonStrings");
   DelObjbyName("editValIP");
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
string FormatStringFromIP(string val_ip)
  {
   if(val_ip=="TRUE") { return("1"); }
   if(val_ip=="FALSE") { return("0"); }
//---
   return(val_ip);
  }
//+------------------------------------------------------------------+
