//+------------------------------------------------------------------+
//|                                                ADD_FUNCTIONS.mqh |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|   DATETIME  STRING   TIME_DATE             |
//+------------------------------------------------------------------+
string TSd(datetime aValue)
  {
   return(TimeToString(aValue,TIME_DATE));
  }
//+------------------------------------------------------------------+
//|   DATETIME  STRING   TIME_MINUTES          |
//+------------------------------------------------------------------+
string TSm(datetime aValue)
  {
   return(TimeToString(aValue,TIME_MINUTES));
  }
//+------------------------------------------------------------------+
//|   DATETIME  STRING                         |
//| TIME_MINUTES|TIME_SECONDS                                        |
//+------------------------------------------------------------------+
string TSms(datetime aValue)
  {
   return(TimeToString(aValue,TIME_MINUTES|TIME_SECONDS));
  }
//+------------------------------------------------------------------+
//|   DATETIME  STRING                                 |
//|   TIME_DATE|TIME_MINUTES                                 |
//+------------------------------------------------------------------+
string TSdm(datetime aValue)
  {
   return(TimeToString(aValue,TIME_DATE|TIME_MINUTES));
  }
//+------------------------------------------------------------------+
//|   DATETIME  STRING                                 |
//|   TIME_DATE|TIME_MINUTES|TIME_SECONDS                    |
//+------------------------------------------------------------------+
string TSdms(datetime aValue)
  {
   return(TimeToString(aValue,TIME_DATE|TIME_MINUTES|TIME_SECONDS));
  }
//+------------------------------------------------------------------+
//|   INTEGER  STRING                                  |
//+------------------------------------------------------------------+
string IS(int aValue)
  {
   return(IntegerToString(aValue));
  }
//+------------------------------------------------------------------+
//|   DOUBLE  STRING                                   |
//+------------------------------------------------------------------+
string DS(double aValue,int amount)
  {
   return(DoubleToString(aValue,amount));
  }
//+------------------------------------------------------------------+
//|   DOUBLE  STRING                      |
//+------------------------------------------------------------------+
string DS2(double aValue)
  {
   return(DoubleToString(aValue,2));
  }
//+------------------------------------------------------------------+
//|   DOUBLE  STRING  DIGITS                   |
//+------------------------------------------------------------------+
string DS_dgt(double aValue,int digit)
  {
   return(DoubleToString(aValue,digit));
  }
//+------------------------------------------------------------------+
//|   STRING  INTEGER                                  |
//+------------------------------------------------------------------+
long SI(string aValue)
  {
   return(StringToInteger(aValue));
  }
//+------------------------------------------------------------------+
//|   STRING  DOUBLE                                   |
//+------------------------------------------------------------------+
double SD(string aValue)
  {
   return(StringToDouble(aValue));
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
double ND2(double aValue)
  {
   return(NormalizeDouble(aValue,2));
  }
//+------------------------------------------------------------------+
//|   DIGITS                                     |
//+------------------------------------------------------------------+
double ND_dgt(double aValue,int digit)
  {
   return(NormalizeDouble(aValue,digit));
  }
//+------------------------------------------------------------------+
//|             |
//|                                                         |
//+------------------------------------------------------------------+
//| [] -  int                                                |
//+------------------------------------------------------------------+
int vDgtMlt(int value)
  {
   if(SS.dgt==3 || SS.dgt==5) { return(value*=10); } else { return(value); }
  }
//+------------------------------------------------------------------+
//|             |
//|                                                         |
//+------------------------------------------------------------------+
//| [] -  double                                             |
//+------------------------------------------------------------------+
double vDgtMlt(double value)
  {
   if(SS.dgt==3 || SS.dgt==5) { return(value*=10); } else { return(value); }
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
bool Testing()
  {
   return(MQL5InfoInteger(MQL5_TESTING));
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
bool Optimization()
  {
   return(MQL5InfoInteger(MQL5_OPTIMIZATION));
  }
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
bool VisualMode()
  {
   return(MQL5InfoInteger(MQL5_VISUAL_MODE));
  }
//+------------------------------------------------------------------+
//|                      |
//+------------------------------------------------------------------+
bool NotTest()
  {
   if(!Testing() && !Optimization() && !VisualMode()) { return(true); } else { return(false); }
  }
//+------------------------------------------------------------------+
