//+------------------------------------------------------------------+
//|                                                 CREATE_PANEL.mqh |
//+------------------------------------------------------------------+
int
width_chart=0,//  
height_chart=0; //  
//---
int font_sz=8;
string bsc_fnt="Calibri";
color fnt_clr=clrWhite; //    
//+------------------------------------------------------------------+
//|  ר                                                    |
//|------------------------------------------------------------------+
void SetInfoPanel()
  {
   if(InfoPanel)
     {
      if(VisualMode() || NotTest())
        {
         int
         fln=0,  //  
         hln=12; //  
         int x0101=100,x0102=10;
         //---
         int
         anchor=ANCHOR_RIGHT_UPPER,
         corner=CORNER_RIGHT_UPPER;
         //---        
         int yV1=0,xV1=125,xV2=10;
         //---
         if(NotTest()) { yV1=18; fln=32; }
         if(VisualMode()) { yV1=1; fln=16; }
         //---
         CreateEdit(0,0,"FonIP","",corner,"Arial",8,clrDimGray,273,80,274,yV1,0,C'15,15,15',1);
         //---
         CreateEdit(0,0,"HeaderIP","EXPERT PARAMETERS",corner,bsc_fnt,8,clrBlack,273,15,274,yV1,2,clrGainsboro,1);
         //---
         CreateLabel(0,0,arr_ip[0],arr_objip[0][0],anchor,corner,bsc_fnt,font_sz,clrWhiteSmoke,x0101,fln,0);
         CreateLabel(0,0,arr_ip[1],""+IS(gPeriod_Ind)+"",anchor,corner,bsc_fnt,font_sz,clrWhiteSmoke,x0102,fln,0);
         //---
         CreateLabel(0,0,arr_ip[2],arr_objip[1][0],anchor,corner,bsc_fnt,font_sz,nmClrTrueFalse((int)gTakeProfit),x0101,fln+hln,0);
         CreateLabel(0,0,arr_ip[3],StrTPSL((int)gTakeProfit),anchor,corner,bsc_fnt,font_sz,ClrTrueFalse((int)gTakeProfit),x0102,fln+hln,0);
         //---
         CreateLabel(0,0,arr_ip[4],arr_objip[2][0],anchor,corner,bsc_fnt,font_sz,nmClrTrueFalse((int)gStopLoss),x0101,fln+hln*2,0);
         CreateLabel(0,0,arr_ip[5],StrTPSL((int)gStopLoss),anchor,corner,bsc_fnt,font_sz,ClrTrueFalse((int)gStopLoss),x0102,fln+hln*2,0);
         //---
         CreateLabel(0,0,arr_ip[6],arr_objip[3][0],anchor,corner,bsc_fnt,font_sz,clrWhiteSmoke,x0101,fln+hln*3,0);
         CreateLabel(0,0,arr_ip[7],StrReversePosition(gReverse),anchor,corner,bsc_fnt,font_sz,ClrTrueFalse(gReverse),x0102,fln+hln*3,0);
         //---
         CreateLabel(0,0,arr_ip[8],arr_objip[4][0],anchor,corner,bsc_fnt,font_sz,clrWhiteSmoke,x0101,fln+hln*4,0);
         CreateLabel(0,0,arr_ip[9],DS2(gLot),anchor,corner,bsc_fnt,font_sz,clrWhiteSmoke,x0102,fln+hln*4,0);
         //---
         ChartRedraw();
        }
     }
   else { DeleteAllExpertObjects(); }
  }
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
void DeleteAllExpertObjects()
  {
   DeleteInfoPanel(); //  -
   DelDialogWindow(lenmObj); //   
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void DeleteInfoPanel()
  {
   DelObjbyName("FonIP");
   DelObjbyName("HeaderIP");
//---
   for(int i=0; i<10; i++)
     { DelObjbyName(arr_ip[i]); }
//---
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
int DelObjbyName(string Name)
  {
   int nm_obj=0;
   bool res=false;
//---
//    
   nm_obj=ObjectFind(ChartID(),Name);
//---
   if(nm_obj>=0) //  
     {
      res=ObjectDelete(ChartID(),Name); // 
      //---
      if(!res)
        { Print("   : ("+IS(Error())+"): "+ErrorDesc(Error())+""); return(false); }
     }
//---
   return(res);
  }
//+------------------------------------------------------------------+
//|   LABEL                                           |
//+------------------------------------------------------------------+
void CreateLabel(long   chrt_id,   // id 
                 int    nmb_wnd,   // id 
                 string lable_nm,  //  
                 string rename,    //  
                 long   anchor,    //  
                 long   corner,    //  
                 string font_bsc,  // 
                 int    font_size, //  
                 color  font_clr,  //  
                 int    x_dist,    //    X
                 int    y_dist,    //    Y
                 long   zorder)    // 
  {
   if(ObjectCreate(chrt_id,lable_nm,OBJ_LABEL,nmb_wnd,0,0)) //  
     {
      ObjectSetString(chrt_id,lable_nm,OBJPROP_TEXT,rename);          //  
      ObjectSetString(chrt_id,lable_nm,OBJPROP_FONT,font_bsc);        //  
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_COLOR,font_clr);      //   
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_ANCHOR,anchor);       //   
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_CORNER,corner);       //   
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_FONTSIZE,font_size);  //   
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_XDISTANCE,x_dist);    //   X
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_YDISTANCE,y_dist);    //   Y
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_SELECTABLE,false);    //   ,  FALSE
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_ZORDER,zorder);       //  /
      ObjectSetString(chrt_id,lable_nm,OBJPROP_TOOLTIP,"\n");         //   ,  "\n"
     }
  }
//+------------------------------------------------------------------+
//|   EDIT                                            |
//+------------------------------------------------------------------+
void CreateEdit(long   chrt_id,   // id 
                int    nmb_win,   //   ()
                string lable_nm,  //  
                string text,      //  
                long   corner,    //  
                string font_bsc,  // 
                int    font_size, //  
                color  font_clr,  //  
                int    xsize,     // 
                int    ysize,     // 
                int    x_dist,    //    X
                int    y_dist,    //    Y
                long   zorder,    // 
                color  clr,       //  
                bool   flgORead)  //    
  {
   if(ObjectCreate(chrt_id,lable_nm,OBJ_EDIT,nmb_win,0,0)) //  
     {
      ObjectSetString(chrt_id,lable_nm,OBJPROP_TEXT,text);            //  
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_CORNER,corner);       //   
      ObjectSetString(chrt_id,lable_nm,OBJPROP_FONT,font_bsc);        //  
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_FONTSIZE,font_size);  //   
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_COLOR,font_clr);      //  
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_BGCOLOR,clr);         //  
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_XSIZE,xsize);         // 
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_YSIZE,ysize);         // 
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_XDISTANCE,x_dist);    //   X
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_YDISTANCE,y_dist);    //   Y
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_SELECTABLE,false);    //   ,  FALSE
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_ZORDER,zorder);       //  /
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_READONLY,flgORead);   //   
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_ALIGN,ALIGN_LEFT);    //    
      ObjectSetString(chrt_id,lable_nm,OBJPROP_TOOLTIP,"\n");         //   ,  "\n"
     }
  }
//+------------------------------------------------------------------+
//|   BMP_LABEL                                       |
//+------------------------------------------------------------------+
void CreateBMPLabel(long   chrt_id,       // id 
                    int    nmb_wnd,       // id 
                    string bmp_nm,        //  
                    string bmp_path_on,   //    ON
                    string bmp_path_off,  //    OFF
                    long   corner,        //  
                    long   anchor,        //  
                    int    x_dist,        //    X
                    int    y_dist,        //    Y
                    bool   stateBMP,      // 
                    long   zorder,        // 
                    string tooltip)       //  
  {
   if(ObjectCreate(chrt_id,bmp_nm,OBJ_BITMAP_LABEL,nmb_wnd,0,0)) //  
     {
      ObjectSetString(chrt_id,bmp_nm,OBJPROP_BMPFILE,0,bmp_path_on);    // BMP    ON
      ObjectSetString(chrt_id,bmp_nm,OBJPROP_BMPFILE,1,bmp_path_off);   // BMP    OFF
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_STATE,stateBMP);          //  
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_CORNER,corner);           //   
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_ANCHOR,anchor);           //   
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_XDISTANCE,x_dist);        //   X
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_YDISTANCE,y_dist);        //   Y
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_SELECTABLE,false);        //   ,  FALSE
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_ZORDER,zorder);           // 
      ObjectSetString(chrt_id,bmp_nm,OBJPROP_TOOLTIP,tooltip);          //   ,  "\n"
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_COLOR,clrNONE);           //    
     }
  }
//+------------------------------------------------------------------+
//|   BUTTON                                          |
//+------------------------------------------------------------------+
void CreateButton(long   chrt_id,   // id 
                  int    nmb_win,   //  
                  string lable_nm,  //  
                  string rename,    //  
                  long   anchor,    //  
                  long   corner,    //  
                  string font_bsc,  // 
                  int    font_size, //  
                  color  font_clr,  //  
                  color  bg_color,  //  
                  color  brd_color, //  
                  int    xsize,     // 
                  int    ysize,     // 
                  int    x_dist,    //    X
                  int    y_dist,    //    Y
                  long   zorder)    // 
  {
   if(ObjectCreate(chrt_id,lable_nm,OBJ_BUTTON,nmb_win,0,0)) //  
     {
      ObjectSetString(chrt_id,lable_nm,OBJPROP_TEXT,rename);             //  
      ObjectSetString(chrt_id,lable_nm,OBJPROP_FONT,font_bsc);           //  
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_COLOR,font_clr);         //   
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_BGCOLOR,bg_color);       //   
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_BORDER_COLOR,brd_color); //   
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_ANCHOR,anchor);          //   
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_CORNER,corner);          //   
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_FONTSIZE,font_size);     //   
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_XSIZE,xsize);            //   X
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_YSIZE,ysize);            //   Y
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_XDISTANCE,x_dist);       //   X
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_YDISTANCE,y_dist);       //   Y
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_SELECTABLE,false);       //   ,  FALSE
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_ZORDER,zorder);         //  /
      ObjectSetString(chrt_id,lable_nm,OBJPROP_TOOLTIP,"\n");            //   ,  "\n"
     }
  }
//+------------------------------------------------------------------+
