//+------------------------------------------------------------------+
//|                                                   GET_STRING.mqh |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
string StrReversePosition(bool Mode)
  {
   string str="";
//---
   switch(Mode)
     {
      case 0  : str="FALSE"; break;
      default : str="TRUE";  break;
     }
//---
   return(str);
  }
//+------------------------------------------------------------------+
//|    TP  SL                                  |
//+------------------------------------------------------------------+
string StrTPSL(int val)
  {
   string str="";
//---
   switch(val)
     {
      case 0  : str="FALSE"; break;
      default : str=IS(val);  break;
     }
//---
   return(str);
  }  
//+------------------------------------------------------------------+
//|   TIMEFRAME                                      |
//+------------------------------------------------------------------+
string TFtoS(int trade_TF)
  {
   string str="";
   int tf_check=NULL;
//---
   if(trade_TF==0) { tf_check=_Period; } else { tf_check=trade_TF; }
//---
   switch(tf_check)
     {
      case PERIOD_M1  : str="m1";  break;
      case PERIOD_M2  : str="m2";  break;
      case PERIOD_M3  : str="m3";  break;
      case PERIOD_M4  : str="m4";  break;
      case PERIOD_M5  : str="m5";  break;
      case PERIOD_M6  : str="m6";  break;
      case PERIOD_M10 : str="m10"; break;
      case PERIOD_M12 : str="m12"; break;
      case PERIOD_M15 : str="m15"; break;
      case PERIOD_M20 : str="m20"; break;
      case PERIOD_M30 : str="m30"; break;
      case PERIOD_H1  : str="H1";  break;
      case PERIOD_H2  : str="H2";  break;
      case PERIOD_H3  : str="H3";  break;
      case PERIOD_H4  : str="H4";  break;
      case PERIOD_H6  : str="H6";  break;
      case PERIOD_H8  : str="H8";  break;
      case PERIOD_H12 : str="H12"; break;
      case PERIOD_D1  : str="D1";  break;
      case PERIOD_W1  : str="W1";  break;
      case PERIOD_MN1 : str="MN1"; break;
     }
//---
   return(str);
  }
//+------------------------------------------------------------------+
